#!/usr/bin/python
# -*- coding: utf-8 -*-
import psyco
from random import randint
import es
import playerlib
from playerlib import getPlayer
import spe_effects
psyco.full()
superhero = es.import_addon('superhero')

def load():
    print "[SH] Successfully loaded Daredevil"
    es.doblock('corelib/noisy_on')

def unload():
    es.doblock('corelib/noisy_off')

def player_spawn(ev):
    userid = str(ev['userid'])
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT':
        return
    if es.exists('userid',userid):
        player = playerlib.getPlayer(userid)
        if superhero.hasHero(userid,'Daredevil'):
            wcs_dead = player.isdead
            if wcs_dead != 1:
                es.delayed(1,'es_xdoblock superhero/heroes/Daredevil/beacon')

def beacon():
    for userid in es.getUseridList():
        if es.exists('userid',userid):
            steamid = es.getplayersteamid(userid)
            if steamid == 'BOT': steamid = es.getplayername(userid)
            player = playerlib.getPlayer(userid)
            wcs_dead = player.isdead
            if wcs_dead != 1:
                if es.getplayerteam(userid) == 3:
                    other = getOtherPlayer(userid)
                    users = '#all'
                    fDelay = 0
                    vOrigin = es.getplayerlocation(userid)
                    fStartRadius = 0
                    fEndRadius = 600
                    szModelPath = 'sprites/lgtning.vmt'
                    iHaloIndex = 0
                    iStartFrame = 0
                    iFrameRate = 255
                    fLife = 0.2
                    fWidth = 10
                    iSpread = 0
                    fAmplitude = 2
                    iRed = randint(0, 0)
                    iGreen = randint(0, 0)
                    iBlue = randint(0, 255)
                    iAlpha = 255
                    iSpeed = 1
                    iFlags = 0
                    spe_effects.beamRingPoint(users, fDelay, vOrigin, fStartRadius,
                        fEndRadius, szModelPath, iHaloIndex,
                        iStartFrame, iFrameRate, fLife, fWidth, iSpread, fAmplitude, iRed,
                        iGreen, iBlue, iAlpha, iSpeed, iFlags)
                else:
                    other = getOtherPlayer(userid)
                    users = '#all'
                    fDelay = 0
                    vOrigin = es.getplayerlocation(userid)
                    fStartRadius = 0
                    fEndRadius = 600
                    szModelPath = 'sprites/lgtning.vmt'
                    iHaloIndex = 0
                    iStartFrame = 0
                    iFrameRate = 255
                    fLife = 0.2
                    fWidth = 10
                    iSpread = 0
                    fAmplitude = 2
                    iRed = randint(0, 255)
                    iGreen = randint(0, 0)
                    iBlue = randint(0, 0)
                    iAlpha = 255
                    iSpeed = 1
                    iFlags = 0
                    spe_effects.beamRingPoint(users, fDelay, vOrigin, fStartRadius,
                        fEndRadius, szModelPath, iHaloIndex,
                        iStartFrame, iFrameRate, fLife, fWidth, iSpread, fAmplitude, iRed,
                        iGreen, iBlue, iAlpha, iSpeed, iFlags)
    es.delayed(2.5,'es_xdoblock superhero/heroes/Daredevil/beacon')

def getOtherPlayer(userid):
    userid = int(userid)
    player = playerlib.getPlayer(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT':
        for player in es.getUseridList():
            if userid != player:
                return player