#!/usr/bin/python
# -*- coding: utf-8 -*-
import es
import playerlib
import effectlib
import random
import psyco
psyco.full()
superhero = es.import_addon('superhero')

def load():
    print "[SH] Invisible Man successfully loaded"
    es.doblock('corelib/noisy_on')

def unload():
    es.doblock('corelib/noisy_off')

def player_spawn(ev):
    userid = ev['userid']
    if es.exists('userid',userid):
        player = playerlib.getPlayer(userid)
        wcs_dead = player.isdead
        if superhero.hasHero(userid,'Invisible Man'):
            if wcs_dead != 1:
                es.delayed(1,'es_xdoblock superhero/heroes/Invisible Man/check_moving')
 
def player_footstep(ev):
    # requires eventscripts_noisy!
    userid = ev['userid']
    if es.exists('userid',userid):
        if superhero.hasHero(userid,'Invisible Man'):
            player = playerlib.getPlayer(userid)
            r,g,b,a = player.getColor() 
            player.set("color", [r, g, b, 255])
            superhero.Users[userid]['oldpos'] = es.getplayerlocation(userid)
            if a != 255:
                es.centertell(userid,"You are not cloaked anymore!")
            
def player_hurt(ev):
    userid = ev['userid']
    if es.exists('userid',userid):
        if superhero.hasHero(userid,'Invisible Man'):
            player = playerlib.getPlayer(userid)
            r,g,b,a = player.getColor() 
            player.set("color", [r, g, b, 255])
            superhero.Users[userid]['oldpos'] = es.getplayerlocation(userid)
            if a != 255:
                es.centertell(userid,"You are not cloaked anymore!")
            
def weapon_fire(ev):
    # Eventscripts_noisy must be 1!
    userid = ev['userid']
    if es.exists('userid',userid):
        if superhero.hasHero(userid,'Invisible Man'):
            player = playerlib.getPlayer(userid)
            r,g,b,a = player.getColor() 
            player.set("color", [r, g, b, 255])
            superhero.Users[userid]['oldpos'] = es.getplayerlocation(userid)
            if a != 255:
                es.centertell(userid,"You are not cloaked anymore!")
    
def check_moving():
    for userid in superhero.Users:
        if es.exists('userid',userid):
            player = playerlib.getPlayer(userid) 
            wcs_dead = player.isdead  
            if superhero.hasHero(userid,'Invisible Man'):        
                if wcs_dead != 1:
                    if not 'oldpos' in superhero.Users[userid]: superhero.Users[userid]['oldpos'] = 0
                    newpos = es.getplayerlocation(userid)
                    oldpos = superhero.Users[userid]['oldpos']
                    if str(newpos) == str(oldpos):
                        r,g,b,a = player.getColor() 
                        if a >= 15:
                            a -= 15
                        invis = a
                        invis = invis * 100 / 255
                        invis = 100-invis
                        es.centertell(userid,invis,'% Cloaked')
                        player.set("color", [r, g, b, a])                       
                    superhero.Users[userid]['oldpos'] = newpos   
    es.delayed(0.4,'es_xdoblock superhero/heroes/Invisible Man/check_moving')